<?php
/*---------------------------------------------------------------*/
/*
    Titre : Anti spam sur les listes de mots clés                                                                        
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=516
    Auteur           : KOogar                                                                                             
    Date dition     : 12 Juin 2009                                                                                       
    Date mise  jour : 22 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - corrections orthographiques de la description                                                                       
*/
/*---------------------------------------------------------------*/

   function anti_spam($texte,$nombre_de_mots_par_separateur,
$nombre_de_mots_total) {
   // DEBUT DU CODE
   $i=0;
   $masque = array(',',';',':','-','_'); // Les séparateurs
   while ($i < count($masque)) {
   $tab_resultat[] = preg_match_all("/([$masque[$i]]+?)/",$texte,$result_nombre)
;
   $i++;
   }

   // Place tous les mots d'une chaine dans un tableau
   $tab_mot = preg_split("/[\s,.:\?-]+/", $texte);
   // compte le nombre de mots
   $nombre_mot = count($tab_mot);

   $i=0;
   $nbre_total_de_resultat = 0;

   while ($i < count($tab_resultat)) {
     // commence par compter le nombre total de separateur que contient le texte
     $nbre_total_de_resultat = $nbre_total_de_resultat + $tab_resultat[$i];
     // pour eviter la division par Zéro
     if ($tab_resultat[$i] == 0) $tab_resultat[$i] = 1;
     // divise le nombre de mots par le nombre de séparateur
     $resultat_mot = $nombre_mot / $tab_resultat[$i];
     // arrondi le résultat
     $resultat_mot = round($resultat_mot);
     if ($resultat_mot <= $nombre_de_mots_par_separateur) {
     // PRINT
     $out = '';
     $out .= '<b>SPAM</b> !! Il y a 1 séparateur <b>"'.$masque[$i].
'"</b> tous les
           <b>'.$resultat_mot.'</b> mots
           et vous en autorisez que <b>'.$nombre_de_mots_par_separateur.
'</b><br />'; }
     else  {
    $out .= '<b>OK !!</b> Il y a 1 séparateur <b>"'.$masque[$i].'"</b> tous les
           <b>'.$resultat_mot.'</b> mots
           et vous autorisez <b>'.$nombre_de_mots_par_separateur.'</b><br />'; }
     $i++;
     }

     if ($nbre_total_de_resultat >= $nombre_de_mots_total)
     // PRINT
     $out .= 'Il y a un problème car il existe <b>'.$nbre_total_de_resultat.
'</b>
     séparateurs dans le texte pour <b>'.$nombre_mot.'</b> mots
     et vous en autorisez que <b>'.$nombre_de_mots_total.'</b>';
     else
     $out .= 'Il y n\'a pas de problème car il existe que <b>'.
$nbre_total_de_resultat.'</b>
     séparateurs  dans le texte pour <b>'.$nombre_mot.'</b> mots
     et vous autorisez <b>'.$nombre_de_mots_total.'</b>';
    return $out;
  }
?>